/* it is -*- c -*- ! */


/* used by addTimeOut */

void
timerProc(command, junk)
XtPointer        command;
XtIntervalId     *junk;
    {
    DBUG_ENTER("timerProc");

    if (Tcl_Eval(interpreter, (char *)command, 0, NULL) == TCL_ERROR)
	fprintf(stderr, "%s\n", interpreter->result);     

    XtFree((char *)command);
    DBUG_VOID_RETURN;
    }




char *
cvtToString(clientData, quarkOfType, freeFuncPtr)
XtPointer     clientData;
XrmQuark      quarkOfType;
freeProc      *freeFuncPtr;
    {
    char     *result;

    DBUG_PRINT("cvtToString", ("Converting to <%s>", 
			       XrmQuarkToString(quarkOfType)));

    if (quarkOfType == qString)
	{
	*freeFuncPtr = TCL_VOLATILE;
	return (char *)clientData;
	}
	
    if (quarkOfType == qInt) 
	{
	*freeFuncPtr = XtFree;
	result = XtMalloc(INT_AS_STRING);
	sprintf(result, "%d", (int)clientData);        	
	return result;
	}
    
    if (quarkOfType == qDimension)
	{
	*freeFuncPtr = XtFree;
	result = XtMalloc(INT_AS_STRING);
	sprintf(result, "%hu", (Dimension)(unsigned long)clientData);	
	return result;
	}

    if (quarkOfType == qCardinal)
	{
	*freeFuncPtr = XtFree;
	result = XtMalloc(INT_AS_STRING);
	sprintf(result, "%lu", (Cardinal)(unsigned long)clientData);	
	return result;
	}
	
    if (quarkOfType == qPosition)
	{
	*freeFuncPtr = XtFree;
	result = XtMalloc(INT_AS_STRING);
	sprintf(result, "%hd", (Position)(long)clientData);        	
	return result;
	}
/*    
    if (quarkOfType == qFloat)
	{
	*freeFuncPtr = XtFree;
	result = XtMalloc(FLOAT_AS_STRING);

	if (sizeof(float)>sizeof(XtPointer)) {
	fprintf(stderr,"groesser\n");
	    sprintf(result, "%f", (*(float *)clientData));
}
	else 
	  {
	  fprintf(stderr,"kleiner,gleich %p %f\n", 
	          clientData, (float)(long)clientData);
	  sprintf(result, "%f", (float)(long)clientData); 
	  }

	return result;
	}

    if (quarkOfType == qDouble)	
	{
	*freeFuncPtr = XtFree;
	result = XtMalloc(FLOAT_AS_STRING);

	if (sizeof(double)>sizeof(XtPointer))
	    sprintf(result, "%f", (*(double *)clientData));
	else 
	    sprintf(result, "%f", clientData);
	return result;
	}
*/
    if (quarkOfType == qBoolean)
	{
	*freeFuncPtr = TCL_STATIC;
	return (Boolean)(int)clientData ? "true" : "false";   
	}
    

        /* last ressort: if nothing helps, try "real" converter */

        {
	XrmValue          input,output;
   
	input.addr =   clientData;  /* ??? */
	input.size =   sizeof(XtPointer);     /* ??? */
	output.addr =  NULL;

	IFCONVERTANDSTORE(topLevel, 
			  XrmQuarkToString(quarkOfType),input, 
			  "String", output)
	  {
	    *freeFuncPtr = XtFree;
	    return output.addr;
	  }
       else
	 return NULL;
       }
    }


String
getValue(w, Qname, freeFuncPtr)
Widget        w;
XrmQuark      Qname;
freeProc     *freeFuncPtr;
    {
    char      *result;
    XrmQuark   Qtype;
    XtPointer  value;
    Arg        arg;

    DBUG_PRINT("getValue", ("widget is %p resource is <%s>",
			    w,XrmQuarkToString(Qname))); 

    if (!(Qtype = getQTypeOfAttribute(XtClass(w), ParentWidget(w), Qname)))
	{
	fprintf(stderr, "Wafe(getValues): Unknown Attribute %s",
		XrmQuarkToString(Qname));
	*freeFuncPtr = TCL_STATIC;
	return NULL;
	}


     /* Callbacks sind ... anders: die String-Information 
	       kommt aus wafe's privatem Memory-Management und nicht 
	       ber getValues!
	     */
    if (Qtype == qCallback) 
	{
	MMattribListPtr ptr = *MMgetAttribList(w);
	
	*freeFuncPtr = TCL_STATIC;
	result = "";
	while(ptr) 
	    {
	    if (ptr->attribute == Qname) 
		{
		result = ((char*)ptr->value) +
		    sizeof(XtCallbackList)*2 +
		    sizeof(XtCallbackRec[2]) +
		    sizeof(XrmQuark);
		break;
		}
	    ptr = ptr->next;
	    }
	}
    else
    if (Qtype == qFloat) 
	{
	float    valueFloat;
	*freeFuncPtr = XtFree;
	result = XtMalloc(FLOAT_AS_STRING);
	XtVaGetValues(w, XrmQuarkToString(Qname), &valueFloat, NULL);
	sprintf(result, "%f", valueFloat);
	}
    else
    if (Qtype == qDouble) 
	{
	double    valueDouble;
	*freeFuncPtr = XtFree;
	result = XtMalloc(FLOAT_AS_STRING);
	XtVaGetValues(w, XrmQuarkToString(Qname), &valueDouble, NULL);
	sprintf(result, "%f", valueDouble);
	}
    else
    if (Qtype == qWidgetList) 
        {
	Widget    *children, *wPtr;
        int        numChildren;
        int        i, length=0;
	char   *ptr;

        XtVaGetValues(w, XtNnumChildren, &numChildren,
                            XtNchildren,    &children,    NULL);
        for (i=0, wPtr=children; i<numChildren; i++, wPtr++)
	   {
	   length += strlen(XtName(*wPtr)) + 2;
	   }
	result = XtMalloc(length);
	*result = '\0';
        for (i=0, wPtr=children; i<numChildren; i++, wPtr++)
	    {
            strcat(result,XtName(*wPtr));
            strcat(result," ");
            }

        *freeFuncPtr = XtFree;  
        }
    else 
	{
/*
	XtVaGetValues(w, XrmQuarkToString(Qname), &value, NULL);
*/
	XtSetArg(arg, XrmQuarkToString(Qname), &value);
	XtGetValues(w, &arg, (Cardinal)1);

	if (!(result = cvtToString(value, Qtype, freeFuncPtr)))
	    {
	      fprintf(stderr, "Wafe(getValues): Couldn't convert value\n");
	      *freeFuncPtr = TCL_STATIC;
	      return NULL;
	    }

	DBUG_PRINT("cvtToString", ("returns <%s>",result)); 
	}
    return result;
    }


int
getResourceList(w, resultPtr)
char    ***resultPtr; 
Widget   w;
    {
    int numTotal, count;
    char **result;
    int rNum = 0;
    int cNum = 0;
    QTypeList rList, cList;

    rNum = getResOfClass(XtClass(w), &rList);

    if (XtIsConstraint(ParentWidget(w)))   /* If parentWidget is constrain widget => fetch constraints */
	cNum =  getConOfClass(XtClass(ParentWidget(w)), &cList);

    numTotal = rNum + cNum;

    *resultPtr = result = (char **)XtMalloc(numTotal *sizeof(char *));       


    for ( count = 0; count < rNum; count++)
	*result++ = XrmQuarkToString(rList[count].qName);

    for ( count = 0; count < cNum; count++)
	*result++ = XrmQuarkToString(cList[count].qName);

    return(numTotal);
    }




