/* -*- c -*- */
#include "rdd.h"

/* RDD myStartAction */
void myStartAction (w, event, args, nargs)
	Widget w;
	XButtonEvent *event;
	String *args;
	int *nargs;
{
	static Pixmap pixmap = NULL;
	Display *dpy = XtDisplay(w);
	Dimension width, height;
	Position  x,y, xRoot, yRoot;
	static GC gc = NULL;

	XtVaGetValues(w, 
		      XtNx,&x, 
		      XtNy,&y,
		      XtNwidth, &width,
		      XtNheight, &height,
		      NULL);
	XtTranslateCoords(w,x,y,&xRoot,&yRoot);
	
	if (!gc) /* probleme mit multiscreen un diff depth */
	    {
	    XGCValues gcv;
	    gcv.subwindow_mode = IncludeInferiors;
	    gc = XCreateGC (dpy, XtWindow(w), GCSubwindowMode, &gcv);
	    }
	
	
	if (pixmap)
	    XFreePixmap(XtDisplay(w), pixmap);

	pixmap = XCreatePixmap (dpy, RootWindow(dpy,0), 
				width, height, XDefaultDepth(dpy,0));

	/* Create a pixmap of the widget */
	
	XCopyArea(dpy, XtWindow(w), pixmap, gc, 0,0, width, height, 0,0);
/*	XCopyArea(dpy, RootWindow(dpy,0), pixmap, gc, x,y, width, height, 0,0);*/
	
	rddSetDragPixmap (pixmap, width, height);
	rddSetDragCursorOffset(event->x, event->y);

	rddStartAction (w, event, args, nargs);		/* then use default action */
}

void
rddWafeInit()
    {
    static XtActionsRec actions[] = 
	{
	"rddDropAction", rddDropAction,
	"wStartAction", myStartAction,
	"rddStartAction", rddStartAction,
	NULL, NULL,
	};
    XtAppAddActions (appContext, actions, XtNumber(actions));
    rddInit(topLevel, appContext);
    }

